; ##############################################################################
; ##############################################################################
; ##############################################################################
; Diese Routine stellt ein ASCII-Zeichen auf dem Display dar.					
; INP: temp	(0...127 ASCII, 128...255 inverses ASCII							
ASCII_TEMP:
	push temp
	push temp1
	push temp8
	push temp9
	push XL
	push XH
	push YL
	push YH
	push ZL
	push ZH

	LDS temp1,(adr_GRAFIC_ASCII_GROESSE)
	cpi temp1,0
	breq ASCII_TEMP_SCHRIFTGROESSE_0
	cpi temp1,1
	breq ASCII_TEMP_SCHRIFTGROESSE_1

ASCII_TEMP_SCHRIFTGROESSE_0:
	rcall ASCII_8x12_TEMP
	rjmp ASCII_TEMP_FERTIG
ASCII_TEMP_SCHRIFTGROESSE_1:
	rcall ASCII_16x24_TEMP
	rjmp ASCII_TEMP_FERTIG

ASCII_TEMP_FERTIG:
	pop ZH
	pop ZL
	pop YH
	pop YL
	pop XH
	pop XL
	pop temp9
	pop temp8
	pop temp1
	pop temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; ASCII   0...127 (normal)														
; ASCII 128...254 (invers)														
; ASCII       255 (Cursor rechts)												
;																				
ASCII_8x12_TEMP:
;-------------------------------------------------------------------------------
	; BERLAUF ?							
	LDS YL,(adr_GRAFIC_ASCII_CURSOR_Y_L)
	LDS YH,(adr_GRAFIC_ASCII_CURSOR_Y_H)
	cpi YH, HIGH(adr_TV_BILDBEREICH_ENDE)
	brlo ASCII_8x12_UEBERLAUF_OK
	breq ASCII_8x12_LOW
	rjmp ASCII_8x12_UEBERLAUF
ASCII_8x12_LOW:
	cpi YL, LOW(adr_TV_BILDBEREICH_ENDE)
	brlo ASCII_8x12_UEBERLAUF_OK
	breq ASCII_8x12_UEBERLAUF_OK
ASCII_8x12_UEBERLAUF:
	rcall ASCII_CURSOR_ZEILE_1 ; Zeile	1
ASCII_8x12_UEBERLAUF_OK:
;-------------------------------------------------------------------------------
	; 255 ?									
	cpi temp,255
	breq ASCII_8x12_CURSOR
;-------------------------------------------------------------------------------
	; FONT-TABELLE initialisieren			
	ldi ZH, high(FONT_8x12*2)
	ldi ZL,  low(FONT_8x12*2)
	mov temp8,temp			; SICHERUNGSKOPIE fr invers	
	ldi temp1,24
	andi temp,0b01111111	; 0...127
	MUL temp,temp1
	add ZL,R0
	adc ZH,R1
;-------------------------------------------------------------------------------
	; ASCII aus TABELLE holen				
	ldi temp9,12					; SCHLEIFE					
ASCII_8x12_s1:
	LPM temp, Z+   					; aus Tabelle laden			
	call FUNCTION_BITUMKEHR_TEMP	; BIT-TAUSCH				
	push temp						; sichern auf STACK			
	LPM temp, Z+   					; DUMMY aus Tabelle laden	
	dec temp9
	brne ASCII_8x12_s1
;-------------------------------------------------------------------------------
	; CURSOR-Zeile							
	LDS YL,(adr_GRAFIC_ASCII_CURSOR_Y_L)
	LDS YH,(adr_GRAFIC_ASCII_CURSOR_Y_H)
;-------------------------------------------------------------------------------
	; ASCII write (von unten nach oben)		
	LDS temp1,(adr_GRAFIC_ASCII_INVERS)	; ASCII invers 			
	ldi temp9,12					; SCHLEIFE					
ASCII_8x12_s2:
	pop temp						; wiederherstellen			
	SBRC temp1,0					; ASCII invers ?			
	com temp						; invertieren				
	SBRC temp8,7					; ASCII invers ?			
	com temp						; invertieren				
	ST Y,temp						; im BILDSPEICHER speichern	
	SBIW YL,40						; +40						
	dec temp9
	brne ASCII_8x12_s2
;-------------------------------------------------------------------------------
ASCII_8x12_CURSOR:
	; CURSOR-SPALTEN-ZHLER					
	LDS temp,(adr_GRAFIC_ASCII_CURSOR_X)
	inc temp
	STS(adr_GRAFIC_ASCII_CURSOR_X),temp
	cpi temp,40
	brsh ASCII_8x12_NEW_ZEILE
	; CURSOR-SPALTE+1						
	LDS YL,(adr_GRAFIC_ASCII_CURSOR_Y_L)
	LDS YH,(adr_GRAFIC_ASCII_CURSOR_Y_H)
	adiw YL,1
	STS(adr_GRAFIC_ASCII_CURSOR_Y_L),YL
	STS(adr_GRAFIC_ASCII_CURSOR_Y_H),YH
	ret
;-------------------------------------------------------------------------------
ASCII_8x12_NEW_ZEILE:
	STS(adr_GRAFIC_ASCII_CURSOR_X),NULL
	; CURSOR-SPALTE							
	LDS YL,(adr_GRAFIC_ASCII_CURSOR_Y_L)
	LDS YH,(adr_GRAFIC_ASCII_CURSOR_Y_H)
	ldi temp,  LOW(40*12-39)
	ldi temp1,HIGH(40*12-39)
	add YL,temp
	adc YH,temp1
	STS(adr_GRAFIC_ASCII_CURSOR_Y_L),YL
	STS(adr_GRAFIC_ASCII_CURSOR_Y_H),YH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; ASCII   0...127 (normal)														
; ASCII 128...254 (invers)														
; ASCII       255 (Cursor rechts)												
;																				
ASCII_16x24_TEMP:
	; BERLAUF ?							
	LDS YL,(adr_GRAFIC_ASCII_CURSOR_Y_L)
	LDS YH,(adr_GRAFIC_ASCII_CURSOR_Y_H)
	cpi YH, HIGH(adr_TV_BILDBEREICH_ENDE)
	brlo ASCII_16x24_UEBERLAUF_OK
	breq ASCII_16x24_LOW
	rjmp ASCII_16x24_UEBERLAUF
ASCII_16x24_LOW:
	cpi YL, LOW(adr_TV_BILDBEREICH_ENDE)
	brlo ASCII_16x24_UEBERLAUF_OK
	breq ASCII_16x24_UEBERLAUF_OK
ASCII_16x24_UEBERLAUF:
	rcall ASCII_CURSOR_ZEILE_2 ; Zeile	2
ASCII_16x24_UEBERLAUF_OK:
;-------------------------------------------------------------------------------
	; ASCII=LEER=255
	cpi temp,255
	breq ASCII_16x24_CURSOR
;-------------------------------------------------------------------------------
	; FONT-TABELLE Z initialisieren			
	ldi ZH, high(FONT_16x24*2)
	ldi ZL,  low(FONT_16x24*2)
	ldi temp1,48
	mov temp8,temp			; SICHERUNGSKOPIE fr invers	
	andi temp,0b01111111	; 0...127
	MUL temp,temp1
	add ZL,R0
	adc ZH,R1
;-------------------------------------------------------------------------------
	; ASCII aus TABELLE holen				
	ldi temp9,24
ASCII_16x24_s1:
	LPM temp, Z+   					; aus Tabelle laden	
	call FUNCTION_BITUMKEHR_TEMP	; BIT-TAUSCH		
	push temp						; sichern			
	LPM temp, Z+   					; aus Tabelle laden	
	call FUNCTION_BITUMKEHR_TEMP	; BIT-TAUSCH		
	push temp						; sichern			
	dec temp9
	brne ASCII_16x24_s1
;-------------------------------------------------------------------------------
	; ASCII write (von unten nach oben)		
	LDS temp1,(adr_GRAFIC_ASCII_INVERS)	; ASCII invers 				
	ldi temp9,24					; SCHLEIFE						
ASCII_16x24_s2:
	pop temp						; wiederherstellen (HIGH)		

	SBRC temp1,0					; ASCII invers ?				
	com temp						; invertieren					

	SBRC temp8,7					; ASCII invers ?				
	com temp						; invertieren					
	ST Y+,temp						; in BILDSPEICHER speichern	Y+1	

	pop temp						; wiederherstellen (LOW)		

	SBRC temp1,0					; ASCII invers ?				
	com temp						; invertieren					

	SBRC temp8,7					; ASCII invers ?				
	com temp						; invertieren					

	ST Y,temp						; in BILDSPEICHER speichern		
	SBIW YL,41						; SRAM-ADRESSE auf nchste ZEILE
	dec temp9
	brne ASCII_16x24_s2
;-------------------------------------------------------------------------------
ASCII_16x24_CURSOR:
	; CURSOR SPALTE							
	LDS temp,(adr_GRAFIC_ASCII_CURSOR_X)
	inc temp
	STS(adr_GRAFIC_ASCII_CURSOR_X),temp
	cpi temp,20
	breq ASCII_16x24_NEW_ZEILE
	; CURSOR-Zeile							
	LDS YL,(adr_GRAFIC_ASCII_CURSOR_Y_L)
	LDS YH,(adr_GRAFIC_ASCII_CURSOR_Y_H)
	adiw YL,2
	STS(adr_GRAFIC_ASCII_CURSOR_Y_L),YL
	STS(adr_GRAFIC_ASCII_CURSOR_Y_H),YH
	ret
;-------------------------------------------------------------------------------
ASCII_16x24_NEW_ZEILE:
	; CURSOR SPALTE							
	STS(adr_GRAFIC_ASCII_CURSOR_X),NULL
	; CURSOR auf neue ZEILE					
	LDS YL,(adr_GRAFIC_ASCII_CURSOR_Y_L)
	LDS YH,(adr_GRAFIC_ASCII_CURSOR_Y_H)
	ldi temp ,LOW (960+2-40)
	ldi temp1,HIGH(960+2-40)
	add YL,temp
	adc YH,temp1
	; CURSOR save 							
	STS(adr_GRAFIC_ASCII_CURSOR_Y_L),YL
	STS(adr_GRAFIC_ASCII_CURSOR_Y_H),YH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne ASCII_TEXT_w
	ret
ASCII_TEXT_w:
	rcall ASCII_TEMP			; Anzeige
	rjmp ASCII_TEXT_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_CURSOR_ZEILE_1:
	push temp
	ldi temp,1
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_2:
	push temp
	ldi temp,2
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_3:
	push temp
	ldi temp,3
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_4:
	push temp
	ldi temp,4
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_5:
	push temp
	ldi temp,5
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_6:
	push temp
	ldi temp,6
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_7:
	push temp
	ldi temp,7
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_8:
	push temp
	ldi temp,8
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_9:
	push temp
	ldi temp,9
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_10:
	push temp
	ldi temp,10
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_11:
	push temp
	ldi temp,11
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_12:
	push temp
	ldi temp,12
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_13:
	push temp
	ldi temp,13
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_14:
	push temp
	ldi temp,14
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_15:
	push temp
	ldi temp,15
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_16:
	push temp
	ldi temp,16
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_17:
	push temp
	ldi temp,17
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_18:
	push temp
	ldi temp,18
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_19:
	push temp
	ldi temp,19
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_20:
	push temp
	ldi temp,20
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_21:
	push temp
	ldi temp,21
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_TEMP:
	push YL
	push YH
	push ZL
	push ZH

	LDS ZL,(adr_GRAFIC_ASCII_GROESSE)
	tst ZL
	breq ASCII_CURSOR_ZEILE_TEMP_RUN
	LSL temp

ASCII_CURSOR_ZEILE_TEMP_RUN:
	ldi YL, LOW (adr_TV_BILDBEREICH)
	ldi YH, HIGH(adr_TV_BILDBEREICH)
	ldi ZL, LOW(40*12)
	ldi ZH,HIGH(40*12)
ASCII_CURSOR_ZEILE_TEMP_s:
	add YL,ZL
	adc YH,ZH
	dec temp
	brne ASCII_CURSOR_ZEILE_TEMP_s

;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_TEMP_FERTIG:
	STS(adr_GRAFIC_ASCII_CURSOR_Y_L),YL
	STS(adr_GRAFIC_ASCII_CURSOR_Y_H),YH
	STS(adr_GRAFIC_ASCII_CURSOR_X),NULL	; CURSOR-SPALTEN-ZHLER					
	pop ZH
	pop ZL
	pop YH
	pop YL
	pop temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


